/* Problem URL: https://codeforces.com/contest/464/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;

struct pt {
    ll x, y, z;

    pt(ll x, ll y, ll z): x(x), y(y), z(z) {}
    pt() = default;
    
    friend istream &operator >> (istream &is, pt &a) {
        is >> a.x >> a.y >> a.z;
        return is;
    }

    friend ostream &operator << (ostream &os, pt a) {
        os << a.x << ' ' << a.y << ' ' << a.z;
        return os;
    }

    pt operator ^ (pt b) {
        return pt(y * b.z- z * b.y, z * b.x - x * b.z, x * b.y - y * b.x);
    }

    ll operator * (pt b) {
        return x * b.x + y * b.y + z * b.z;
    }

    pt operator - (pt b) {
        return pt(x - b.x, y - b.y, z - b.z);
    }

    bool operator == (pt b) {
        return x == b.x && y == b.y && z == b.z;
    }

    bool operator < (pt b) {
        if (x == b.x) {
            if (y == b.y) {
                return z < b.z;
            }
            return y < b.y;
        }
        return x < b.x;
    }
};

ll dis2(pt a, pt b)
{
    ll x = a.x - b.x;
    ll y = a.y - b.y;
    ll z = a.z - b.z;

    return x * x + y * y + z * z;
}

void pre()
{

}

#define TEST 0

void solve()
{
    vvi pts(8, vi(3));
    cin >> pts;

    rep(i, 8) {
        sortv(pts[i]);
    }
    
    auto check = [&](){
        V<pt> p(8);
        rep(i, 8) {
            p[i] = {pts[i][0], pts[i][1], pts[i][2]};
        }

        sortv(p);
        p.erase(unique(all(p)), p.end());

        if (p.size() != 8) {
            return false;
        }

        vi dis(7);
        nrep(i, 1, 8) {
            dis[i - 1] = dis2(p[i], p[0]);
        }

        sortv(dis);

        nrep(i, 1, 8) {
            vi d2;
            rep(j, 8) {
                if (i == j) {
                    continue;
                }

                d2.push_back(dis2(p[i], p[j]));
            }

            sortv(d2);
            if (d2 != dis) {
                return false;
            }
        }

        return true;
    };

    function<bool(int)> func = [&](int i){
        if (i >= 8) {
            return check();
        }

        do {
            if (func(i + 1)) {
                return true;
            }
        } while (next_permutation(all(pts[i])));

        return false;
    };

    if (!func(0)) {
        cout << "NO\n";
        return;
    }

    cout << "YES\n";
    cout << pts;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
